/*
Copyright 2020 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	time "time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
	operatorv1alpha1 "knative.dev/operator/pkg/apis/operator/v1alpha1"
	versioned "knative.dev/operator/pkg/client/clientset/versioned"
	internalinterfaces "knative.dev/operator/pkg/client/informers/externalversions/internalinterfaces"
	v1alpha1 "knative.dev/operator/pkg/client/listers/operator/v1alpha1"
)

// KnativeServingInformer provides access to a shared informer and lister for
// KnativeServings.
type KnativeServingInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.KnativeServingLister
}

type knativeServingInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewKnativeServingInformer constructs a new informer for KnativeServing type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewKnativeServingInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredKnativeServingInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredKnativeServingInformer constructs a new informer for KnativeServing type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredKnativeServingInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.OperatorV1alpha1().KnativeServings(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.OperatorV1alpha1().KnativeServings(namespace).Watch(context.TODO(), options)
			},
		},
		&operatorv1alpha1.KnativeServing{},
		resyncPeriod,
		indexers,
	)
}

func (f *knativeServingInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredKnativeServingInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *knativeServingInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&operatorv1alpha1.KnativeServing{}, f.defaultInformer)
}

func (f *knativeServingInformer) Lister() v1alpha1.KnativeServingLister {
	return v1alpha1.NewKnativeServingLister(f.Informer().GetIndexer())
}
